洛谷 P1948 [USACO08JAN]电话线Telephone Lines

题目描述

Farmer John wants to set up a telephone line at his farm. Unfortunately, the phone company is uncooperative, so he needs to pay for some of the cables required to connect his farm to the phone system.

There are N (1 ≤ N ≤ 1,000) forlorn telephone poles conveniently numbered 1..N that are scattered around Farmer John's property; no cables connect any them. A total of P (1 ≤ P ≤ 10,000) pairs of poles can be connected by a cable; the rest are too far apart.

The i-th cable can connect the two distinct poles Ai and Bi, with length Li (1 ≤ Li ≤ 1,000,000) units if used. The input data set never names any {Ai, Bi} pair more than once. Pole 1 is already connected to the phone system, and pole N is at the farm. Poles 1 and N need to be connected by a path of cables; the rest of the poles might be used or might not be used.

As it turns out, the phone company is willing to provide Farmer John with K (0 ≤ K < N) lengths of cable for free. Beyond that he will have to pay a price equal to the length of the longest remaining cable he requires (each pair of poles is connected with a separate cable), or 0 if he does not need any additional cables.

Determine the minimum amount that Farmer John must pay.

多年以后,笨笨长大了,成为了电话线布置师。由于地震使得某市的电话线全部损坏,笨笨是负责接到震中市的负责人。该市周围分布着N(1<=N<=1000)根据1……n顺序编号的废弃的电话线杆,任意两根线杆之间没有电话线连接,一共有p(1<=p<=10000)对电话杆可以拉电话线。其他的由于地震使得无法连接。

第i对电线杆的两个端点分别是ai,bi,它们的距离为li(1<=li<=1000000)。数据中每对(ai,bi)只出现一次。编号为1的电话杆已经接入了全国的电话网络,整个市的电话线全都连到了编号N的电话线杆上。也就是说,笨笨的任务仅仅是找一条将1号和N号电线杆连起来的路径,其余的电话杆并不一定要连入电话网络。

电信公司决定支援灾区免费为此市连接k对由笨笨指定的电话线杆,对于此外的那些电话线,需要为它们付费,总费用决定于其中最长的电话线的长度(每根电话线仅连接一对电话线杆)。如果需要连接的电话线杆不超过k对,那么支出为0.

请你计算一下,将电话线引导震中市最少需要在电话线上花多少钱?

输入输出格式

输入格式:

 

输入文件的第一行包含三个数字n,p,k;

第二行到第p+1行,每行分别都为三个整数ai,bi,li。

 

输出格式:

 

一个整数,表示该项工程的最小支出,如果不可能完成则输出-1.

 

输入输出样例

输入样例#1:
5 7 1
1 2 5
3 1 4
2 4 8
3 2 3
5 2 9
3 4 7
4 5 6
输出样例#1:
4
思路:spfa+二分。本题实际就是求1到n路径上k+1大的边最小是几,自然而然的就想到了二分,二分那条边是第k+1条边。
错因:没有分析最终边数小于k时,答案是0的情况(洛谷不分析AC了,cogsWA了一个点)
吐槽:洛谷的数据太水了。
#include<queue>
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#define MAX 1001
#define MAXN 10001
using namespace std;
struct nond{
    int x,y,z;
}edge[MAXN];
int n,p,k,l,r,mid,ans=-1,tot,num;
int dis[MAX],vis[MAX];
int to[MAXN*2],head[MAXN*2],net[MAXN*2],cap[MAXN*2];
int cmp(nond a,nond b){
    return a.z<b.z;
}
void add(int u,int v,int w){
    to[++tot]=v;net[tot]=head[u];cap[tot]=w;head[u]=tot;
    to[++tot]=u;net[tot]=head[v];cap[tot]=w;head[v]=tot;
}
bool spfa(int s){
    queue<int>que;
    memset(vis,0,sizeof(vis));
    memset(dis,0x3f,sizeof(dis));
    que.push(s);
    vis[s]=1;dis[s]=0;
    while(!que.empty()){
        int now=que.front();
        que.pop();
        vis[now]=0;
        for(int i=head[now];i;i=net[i]){
            if(dis[to[i]]>dis[now]+(cap[i]>edge[mid].z)){
                dis[to[i]]=dis[now]+(cap[i]>edge[mid].z);
                if(!vis[to[i]]){
                    vis[to[i]]=1;
                    que.push(to[i]);
                }
            }
        }
    }
}
int main(){
    //freopen("phoneline.in","r",stdin);
    //freopen("phoneline.out","w",stdout);
    scanf("%d%d%d",&n,&p,&k);
    for(int i=1;i<=p;i++){
        scanf("%d%d%d",&edge[i].x,&edge[i].y,&edge[i].z);
        add(edge[i].x,edge[i].y,edge[i].z);
    }
    sort(edge+1,edge+1+p,cmp);
    spfa(1);
    if(dis[n]==1061109567){
        cout<<"-1";
        return 0; 
    } 
    l=1;r=p;
    while(l<r){
        mid=(l+r)/2;
        spfa(1);
        if(dis[n]>k)    l=mid+1;
        else{
            r=mid;
            ans=edge[mid].z;
        }
    }
    if(dis[n]<k)    cout<<"0";
    else cout<<ans; 
}

怕你飞远去 怕你离我而去

  更怕你永远停留在这里

    每一滴泪水 都向你流淌去

       倒流进天空的海底

posted @ 2017-09-03 11:25  一蓑烟雨任生平  阅读(182)  评论(0编辑  收藏  举报